/* This is a simple demo of a Rexx (modelled after the JavaScript) script that
   uses the Java URL class to download some content from some URL. rgf, 2003-01-24 */

   /* use the Java URL class to read data from a WWW server */
URL_ADDR = "http://www.RexxLA.org/";

say "connecting to:" URL_ADDR
url=bsf("registerBean", "", "java.net.URL", "String", URL_ADDR)

   /* get the content, a <sun.net.www.http.KeepAliveStream> a subclass of:
                         <sun.net.www.MeteredStream>, a subclass of:
                         <java.io.FilterInputStream> */
content = bsf('invoke', url, "getContent")                  /* get the content   */
count=bsf("invoke", content, "available")  /* get # of bytes    */
say "Bytes available:" count

-- byteArray=bsf("registerBean", "", "java.lang.reflect.Array",

    /* create a Byte array */
byteArray=bsf('invoke', 'Array.class', 'newInstance', 'obj', 'byte.class','int', count)
say "bytearray.length():" bsf('invoke', byteArray, 'toString')
say "bytearray.length():" bsf('arrayLength', byteArray)

   /* read everything into the byte-array */
res=bsf('invoke', content, 'read', 'obj', byteArray, 'int', 0, 'int', count)
say "res:" res
data=bsf('registerBean', '', 'java.lang.String', 'o', byteArray)
-- x2=bsf('invoke', 'String.class', 'new', 'o', byteArray)
say "data:" data "x2:" x2
say "strlen:" bsf('invoke', data, 'length')


oho=bsf('invoke', data, 'toString') -- o.k.
-- say "bevor: exit";exit

say "unregisterBean:" bsf('unregisterBean', data)

say "length(oho):" length(oho)
say "data = >>> ["|| oho ||"] <<<"
-- res=bsf('invoke', 'String.class', 'String', 'byte'
say "after ..., now exiting"
exit


   /* read the content */
say "Downloading .. "
ch=""
do until ch=-1
   ch=bsf('invoke', content, "read")      /* returns an Integer value representing a Byte or -1 */
   if ch>=0 then call charout , d2c(ch)   /* turn Byte integer value into character */
end

